precision lowp float;



uniform sampler2D s_Sphere;

uniform sampler2D s_Normal0;

#ifdef ALPHA

uniform sampler2D s_Fade;

#endif



varying highp vec3 v_ViewDir;

varying mediump vec2 v_TexCoord0;

varying mediump vec2 v_TexCoord1;

#ifdef ALPHA

varying mediump vec2 v_TexCoordFade;

#endif



void main()

{

	vec3 normal0 = texture2D(s_Normal0, v_TexCoord0).xyz;

	vec3 normal1 = texture2D(s_Normal0, v_TexCoord1).xyz;

	vec3 normal = (normal0 + normal1) * 0.5 - vec3(0.5, 0.5, 0.5);

	// Note that we work in a transposed space whereby y and z are swapped.	

	normal = normalize(normal);

	vec3 view = normalize(v_ViewDir);

	vec3 reflection = reflect(view, normal);

	vec2 sphere_coords = (reflection.xy * -0.475 + vec2(0.5, 0.5));

	gl_FragColor = texture2D(s_Sphere, sphere_coords);

	#ifdef ALPHA

	gl_FragColor.a = texture2D(s_Fade, v_TexCoordFade).r;

	#endif

}

