uniform vec3 u_CamPos;

uniform mat4 u_ViewProj;



uniform vec2 u_TexOffset0;

uniform vec2 u_TexOffset1;

uniform float u_TexScale0;

uniform float u_TexScale1;

uniform float u_Size;



attribute vec4 a_Position;

attribute vec2 a_Texcoord;



varying highp vec3 v_ViewDir;

varying mediump vec2 v_TexCoord0;

varying mediump vec2 v_TexCoord1;

#ifdef ALPHA

varying mediump vec2 v_TexCoordFade;

#endif



void main()

{

	vec4 world_pos = vec4(a_Position.xyz * u_Size, 1.0);

    gl_Position = u_ViewProj * world_pos;

    // We swap y and z to avoid expensive swizzling in the fragment shader.

	v_ViewDir = (world_pos.xyz - u_CamPos ).xzy;

	v_TexCoord0 = a_Texcoord * u_TexScale0 + u_TexOffset0;

	v_TexCoord1 = a_Texcoord * u_TexScale1 + u_TexOffset1;

	#ifdef ALPHA

	v_TexCoordFade = a_Texcoord;

	#endif

}

